sig World {ジュリア殺害真相: Hat}//世界はいくつあってもよい。(oneを入れていない）
abstract sig Hat {}
one sig ヘレン知る,ヘレン知らない extends Hat {}//-- ジュリア殺害真相をヘレンが知るか知らないか、世界はどちらか。
abstract sig Honest {}
one sig 嘘つき,正直 extends Honest {}//
one sig RealWorld extends World {}
abstract sig Person {access: World -> World,Honest:Honest}//人物は世界にアクセスできる、かつ正直か嘘つきかの属性を持つ。
one sig ホームズ extends Person {}//登場人物はホームズとヘレンのみ
one sig ヘレン extends Person {}
abstract sig liveordead{}
one sig ロイロット死 extends liveordead{} //ロイロットは死か

// S5 様相論理の公理 -- 世界の同値関係と推移関係の定義
fact S5 {all p : Person | {
		// reflexive
	 	all w : World | all w':World| w' in p.access[w] => w in p.access[w']	
		// symmetric and transitive (if u->v and u->w then v->w)
		all w : World | all w' : p.access[w] | all w'' : p.access[w] | w'' in p.access[w']
	}}
//すべての世界
fact DifferentWorldsAreDifferent {
	all w : World | all w' : World {(w.ジュリア殺害真相 = w'.ジュリア殺害真相) => w = w'}
}
//世界は、ジュリア殺害方法をヘレンが知るか、ヘレンが知らないかの２つの世界がある。
fact {	all w: World  {(w.ジュリア殺害真相 = ヘレン知る)
		    or (w.ジュリア殺害真相 = ヘレン知らない) }}

// ヘレン自身は、世界がどちらか知っている。
fact {all w: World | ヘレン.access[w] = {w': World | w.ジュリア殺害真相 = w'.ジュリア殺害真相}}

// ヘレンが正直ならば、ホームズはヘレンが知っているか知らないかを知っている。
fact { (ヘレン.Honest=正直) => all w: World | ヘレン.access[w] = ホームズ.access[w]}
//ヘレンが嘘つきならば、ホームズは情報がない。
fact { (ヘレン.Honest=嘘つき) => no ホームズ.access}

// 人が世界を知っていることを定義している。
pred knows[p: Person, w: World, u: set World] {
	all w1: (p.access[w] & u) | all w2: (p.access[w] & u) |
		w1.ジュリア殺害真相 = w2.ジュリア殺害真相}

//ロイロットは死んだことをFACTとして記述。
fact{ロイロット死= liveordead}
//ホームズは正直としている。
fact{ホームズ.Honest=正直}

pred statement[w:RealWorld] {    
   //ヘレンが殺害方法を知っており、かつ、ホームズが、ジュリア殺害方法をヘレンが知っていることを知っていたならば、ロイロットは死なない。
  ( w.ジュリア殺害真相 = ヘレン知る and ヘレン.access[w] in ホームズ.access[w] ) => ( ロイロット死 != liveordead )  
}
//ヘレンが、アクセスできる世界をホームズが知らないならば、ジュリアは殺害の真相をしっている。
assert ヘレンのたくらみ{all w': ヘレン.access[World] | not knows[ホームズ,w',World] => w'.ジュリア殺害真相 = ヘレン知る}
//check ヘレンのたくらみ
run statement 


